% Archana Gupta
% CIS 601 Assignment 1

clear all;
clc;

% Declare avi file name
aviFileName = 'archie.avi';
% Declare and set avi frames per second
framesPerSec = 10; 
% Declare avi object
aviobj = avifile(aviFileName,'fps',framesPerSec);
% Declare frame and set start value
frame = 1;

%display text
for i = 1:15
    a = 0; b = 255; c = 200;
    x = a + (b-a) * rand(c);
    x = (b/2) + zeros(c);

    imagesc(x);
    axis off;
   
    colordef black;
        % show text
        text(100,50,'The Propeller','FontSize',36,'FontWeight','bold','Color','r','HorizontalAlignment','center');
        text(100,80,'By','FontSize',16,'FontWeight','normal','Color','k','HorizontalAlignment','center','FontAngle','italic');
        text(100,130,'Archana Gupta','FontSize',16,'FontWeight','normal','Color','k','HorizontalAlignment','center','FontAngle','italic');
        text(100,150,'CIS 601','FontSize',16,'FontWeight','normal','Color','k','HorizontalAlignment','center','FontAngle','italic');
        
        % store figure in movie file
        aviobj = addframe(aviobj,getframe);
        frame = frame + 1;
        clf;
    end
    
    %  initial shapes: square,cube
        
        cube = [-0.5, -0.5, -0.5, -0.5, -0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, -0.5, -0.5, 0.5, 0.5, -0.5;
                 0, 0, 1, 1, 0, 0, 0, 1, 1, 0, 0, 0, 1, 1, 1, 1;
                -0.5, 0.5, 0.5, -0.5, -0.5, -0.5, 0.5, 0.5, -0.5, -0.5, 0.5, 0.5, 0.5, 0.5, -0.5, -0.5;
                 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1];
       
        square = [-0.5, -0.5, 0.5, 0.5, -0.5;
                  -0.5, 0.5, 0.5, -0.5, -0.5;
                  0, 0, 0, 0, 0;
                  1, 1, 1, 1, 1];     
      
    %original cube          
       for i=1:6
           
           f=[1 2 3 4];
           fvcc = [ 0 1 0];
           
           plot3(cube(1,:), cube (2,:),cube(3,:),'r');
           text(0,4,0,'original cube','FontSize',16,'Color','r');
           axis([-18 18 -5 26]);
           view(3);
     
      aviobj = addframe(aviobj,getframe);
      frame = frame + 1;
      clf;
  end
  
 %scaling 
  for i=0:1:10
      hsx = i;
      hsy = i;
      hsz = i;
      hscale = scale3D (hsx, hsy, hsz);           
      housescale = (hscale * cube);
      newhscale = housescale(1:3,:);
                  
      plot3(newhscale(1,:),newhscale (2,:), newhscale (3,:),'g');
      text(0,0,7,'scaling','FontSize',16,'Color','g');   
      axis([-18 18 -5 26]);
      view(3);
      
      % store figure in movie file
      aviobj = addframe(aviobj,getframe);
      frame = frame + 1;
      clf;
  end
   
    %translate
  for i=0:-1:-10
      htrans = translate3D (i, 0.0, 0.0);
      housetrans = (htrans * cube);
      newhtrans = housetrans(1:3,:);
        
      plot3(newhtrans(1,:),newhtrans (2,:), newhtrans (3,:),'c');
      text(0,4,0,'Translate','FontSize',16,'Color','c');        
      axis([-18 18 -5 26]);
      view(3);
        
      % store figure in movie file
      aviobj = addframe(aviobj,getframe);
      frame = frame + 1;
      clf;
  end
   
  %rotate about z  
    for i=0.1:30
                
        hrot = rotate3Dz (degree_to_radian (i));
        houserot = (hrot * housescale) ;
        newhrot=houserot(1:3,:);
        
        plot3(newhrot(1,:),newhrot(2,:),newhrot(3,:),'m');
        text(0,8,2,'Rotate Cube (z-axis)','FontSize',16,'Color','m');
        axis([-18 18 -5 26]);
        view(3);
        
        % store figure in movie file
        aviobj = addframe(aviobj,getframe);
        frame = frame + 1;
        clf;
    end
    
   %rotate about x
    for i=0.1:30
                
        horient = rotate3Dx (degree_to_radian (i));
        houseorient = (horient * housescale) ;
        newhorient=houseorient(1:3,:);
        plot3(newhorient(1,:),newhorient(2,:),newhorient(3,:),'b');
        
        text(0,8,2,'Rotate Cube (X-axis)','FontSize',16,'Color','b');    
        axis([-18 18 -5 26]);
        view(3);
          
        % store figure in movie file
        aviobj = addframe(aviobj,getframe);
        frame = frame + 1;
        clf;
    end
     
    
    %propeller support
    for i=1:20
        
        hsx = 2.0;
        hsy = 1.5;
        hsz = 1.0;
        hscale = scale3D (hsx, hsy, hsz);
       
        
        htrans = translate3D (4.0, 10.0, -0.15);
        
        house=htrans*hscale*cube;
        
        hidden off;
        plot3(house(1,:),house (2,:),house (3,:),'r');
        text(0,10,0,'propeller support','FontSize',20,'Color','r');
     
        axis([-18 18 -8 26]);
        view(3);
        % store figure in movie file
        aviobj = addframe(aviobj,getframe);
        frame = frame + 1;
    end
    
    for i=1:20
        
        plot3(house(1,:),house (2,:),house (3,:),'r');
        axis([-18 18 -5 26]);
        view(3);
        hold on;
        
     %parameters for the blades of the windmill  
        z = degree_to_radian (10.0);
	    y= degree_to_radian (20.0);
	    x = degree_to_radian (-70.0);
	    g = rotate3Dz (z) * rotate3Dy (y) * rotate3Dx (x);

        hrot = rotate3Dz (degree_to_radian (30));
        htrans = translate3D (8.0,5.0, 7.0);
        house_orient = g * htrans * hrot;
        
        shaft_axis = translate3D (19, 5, 5);
        bladesx = 22.0;
        bladesy = 6.5;
        blade_scale = scale3D (bladesx, bladesy, 0.0);
        prop_mat = rotate3Dx (degree_to_radian (20));
        blade_orientx = rotate3Dx (degree_to_radian (90.0));
        blade_trans = translate3D (0.5*bladesx, 0.0, 0.0);
        blade_xform = house_orient * shaft_axis * prop_mat * blade_orientx;
        blade_pts = blade_scale * square;
        blade1 = blade_xform * blade_trans * blade_pts;
        blade_fan = rotate3Dz (degree_to_radian (90.0));
        blade2 = blade_xform * blade_fan * blade_trans * blade_pts;
        blade_fan = rotate3Dz (degree_to_radian (180.0));
        blade3 = blade_xform * blade_fan * blade_trans * blade_pts;
        blade_fan = rotate3Dz (degree_to_radian (270.0));
        blade4 = blade_xform * blade_fan * blade_trans * blade_pts;
	
	%plot the blades
	plot (blade1 (1,:), blade1 (2,:),'g');
    hold on;
	plot (blade2 (1,:), blade2 (2,:),'g');
    hold on;
	plot (blade3 (1,:), blade3 (2,:),'g');
    hold on;
	plot (blade4 (1,:), blade4 (2,:),'g');
	hold;
	
    
        axis([-18 18 -5 26]);
        
       view(3);
        % store figure in movie file
        aviobj = addframe(aviobj,getframe);
        frame = frame + 1;
       
    end
    
    for i=0:10:1180
        
        plot3(house(1,:),house (2,:),house (3,:),'r');
        axis([-18 18 -5 26]);
        view(3);
        hold on;
        
     %parameters for the blades of the windmill       
        vroll = degree_to_radian (10.0);
        vpitch = degree_to_radian (20.0);
        vyaw = degree_to_radian (-70.0);
        g = rotate3Dz (vroll) * rotate3Dy (vpitch) * rotate3Dx (vyaw);
        hrot = rotate3Dz (degree_to_radian (30));
        htrans = translate3D (8.0,5.0, 7.0);
        house_orient = g * htrans * hrot;

     	shaft_axis = translate3D (19, 3, 5);
        bladesx = 22.0;	
        bladesy = 6.5;
        blade_scale = scale3D (bladesx, bladesy, 0.0);
        prop_mat = rotate3Dx (degree_to_radian (20));
        blade_orientx = rotate3Dx (degree_to_radian (90.0));
        blade_trans = translate3D (0.5*bladesx, 0.0, 0.0);
        blade_xform = house_orient * shaft_axis * prop_mat * blade_orientx;
        blade_pts = blade_scale * square;
     
    %rotating the blades   
        blade_fan = rotate3Dz (degree_to_radian (i));
        blade1 = blade_xform * blade_fan * blade_trans * blade_pts;
        blade_fan = rotate3Dz (degree_to_radian (i+90));
        blade2 = blade_xform * blade_fan * blade_trans * blade_pts;
        blade_fan = rotate3Dz(degree_to_radian (i+180));
        blade3 = blade_xform * blade_fan * blade_trans * blade_pts;
        blade_fan = rotate3Dz (degree_to_radian (i+270));
        blade4 = blade_xform * blade_fan * blade_trans * blade_pts;
	
	 %plotting the blades
	    plot (blade1 (1,:), blade1 (2,:),'g');
        hold on;
        plot (blade2 (1,:), blade2 (2,:),'g');
        hold on;
        plot (blade3 (1,:), blade3 (2,:),'g');
        hold on;
        plot (blade4 (1,:), blade4 (2,:),'g');
        hold;
        
        text(-10,12,0,'The propeller' ,'FontSize',20,'Color','m');
	
        axis([-28 18 -5 26]);
        view(3);
        axis off;
         
        % store figure in movie file
        aviobj = addframe(aviobj,getframe);
        frame = frame + 1;
        clf;
    end
    
    for i=1:5
        text(50,50,0,'The End','FontSize',36,'FontWeight','bold','Color','r','HorizontalAlignment','center');
        axis([-28 18 -5 26]);
        view(3);
        axis off;
        % store figure in movie file
        aviobj = addframe(aviobj,getframe);
        frame = frame + 1;
        clf;
    end
        
    % movie(M)
% close the avi movie object
aviobj = close(aviobj);